---
title: Arrow function expressions
slug: Web/JavaScript/Reference/Functions/Arrow_functions
tags:
  - ECMAScript 2015
  - Functions
  - Intermediate
  - JavaScript
  - Language feature
  - Reference
---
<div>{{jsSidebar("Functions")}}</div>

<p>An <strong>arrow function expression</strong> is a compact alternative to a traditional <a href="/en-US/docs/Web/JavaScript/Reference/Operators/function">function expression</a>, but is limited and can't be used in all situations.</p>

<p><strong>Differences &amp; Limitations:</strong></p>

<ul>
 <li>Does not have its own bindings to <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this</a></code> or <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/super">super</a></code>, and should not be used as <code><a href="/en-US/docs/Glossary/Method">methods</a></code>.</li>
 <li>Does not have <code><a href="/en-US/docs/Web/JavaScript/Reference/Functions/arguments">arguments</a></code>, or <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/new.target">new.target</a></code> keywords.</li>
 <li>Not suitable for <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/call">call</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/apply">apply</a></code> and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind"><code>bind</code></a> methods, which generally rely on establishing a <a href="/en-US/docs/Glossary/Scope"><code>scope</code>.</a></li>
 <li>Can not be used as <code><a href="/en-US/docs/Glossary/constructor">constructors</a></code>.</li>
 <li>Can not use <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/yield">yield</a></code>, within its body.</li>
</ul>

<div>{{EmbedInteractiveExample("pages/js/functions-arrow.html")}}</div>

<h3 id="Comparing_traditional_functions_to_arrow_functions">Comparing traditional functions to arrow functions</h3>

<p>Let's decompose a "traditional function" down to the simplest "arrow function" step-by-step:<br>
 NOTE: Each step along the way is a valid "arrow function"</p>

<pre class="brush: js notranslate">// Traditional Function
function (a){
  return a + 100;
}

// Arrow Function Break Down

// 1. Remove the word "function" and place arrow between the argument and opening body bracket
(a) =&gt; {
  return a + 100;
}

// 2. Remove the body brackets and word "return" -- the return is implied.
(a) =&gt; a + 100;

// 3. Remove the argument parentheses
a =&gt; a + 100;</pre>

<div class="notecard note">
<p>As shown above, the { brackets } and ( parentheses ) and "return" are optional, but may be required.</p>
</div>

<p>For example, if you have <strong>multiple arguments</strong> or <strong>no arguments</strong>, you'll need to re-introduce parentheses around the arguments:</p>

<pre class="brush: js notranslate">// Traditional Function
function (a, b){
  return a + b + 100;
}

// Arrow Function
(a, b) =&gt; a + b + 100;

// Traditional Function (no arguments)
let a = 4;
let b = 2;
function (){
  return a + b + 100;
}

// Arrow Function (no arguments)
let a = 4;
let b = 2;
() =&gt; a + b + 100;</pre>

<p>Likewise, if the body requires<strong> additional lines</strong> of processing, you'll need to re-introduce brackets <strong>PLUS the "return"</strong> (arrow functions do not magically guess what or when you want to "return"):</p>

<pre class="brush: js notranslate">// Traditional Function
function (a, b){
  let chuck = 42;
  return a + b + chuck;
}

// Arrow Function
(a, b) =&gt; {
  let chuck = 42;
  return a + b + chuck;
}</pre>

<div>And finally, for <strong>named functions</strong> we treat arrow expressions like variables</div>

<div>
<pre class="brush: js notranslate">// Traditional Function
function bob (a){
  return a + 100;
}

// Arrow Function
let bob = a =&gt; a + 100;</pre>
</div>

<h2 id="Syntax">Syntax</h2>

<h3 id="Basic_syntax">Basic syntax</h3>

<p class="syntaxbox notranslate">One param. With simple expression return is not needed:</p>

<pre class="brush: js notranslate">param =&gt; expression</pre>

<p class="syntaxbox notranslate">Multiple params require parentheses. With simple expression return is not needed:</p>

<pre class="brush: js notranslate">(param1, paramN) =&gt; expression</pre>

<p class="syntaxbox notranslate">Multiline statements require body brackets and return:</p>

<pre class="brush: js notranslate">param =&gt; {
  let a = 1;
  return a + param;
}</pre>

<p class="syntaxbox notranslate">Multiple params require parentheses. Multiline statements require body brackets and return:</p>

<pre class="brush: js notranslate">(param1, paramN) =&gt; {
   let a = 1;
   return a + param1 + paramN;
}</pre>

<h3 id="Advanced_syntax">Advanced syntax</h3>

<p class="syntaxbox notranslate">To return an object literal expression requires parentheses around expression:</p>

<pre class="brush: js notranslate">params =&gt; ({foo: "a"}) // returning the object {foo: "a"}</pre>

<p class="syntaxbox notranslate"><a href="/en-US/docs/Web/JavaScript/Reference/Functions/Rest_parameters">Rest parameters</a> are supported:</p>

<pre class="brush: js notranslate">(a, b, ...r) =&gt; expression</pre>

<p class="syntaxbox notranslate"><a href="/en-US/docs/Web/JavaScript/Reference/Functions/Default_parameters">Default parameters</a> are supported:</p>

<pre class="brush: js notranslate">(a=400, b=20, c) =&gt; expression</pre>

<p class="brush: js"><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment">Destructuring</a> within params supported:</p>

<pre class="brush: js notranslate">([a, b] = [10, 20]) =&gt; a + b;  // result is 30
({ a, b } = { a: 10, b: 20 }) =&gt; a + b; // result is 30
</pre>

<h2 id="Description">Description</h2>

<p>See also <a href="https://hacks.mozilla.org/2015/06/es6-in-depth-arrow-functions/">"ES6 In Depth: Arrow functions" on hacks.mozilla.org</a>.</p>

<h3 id="this_and_Arrow_Functions">"this" and Arrow Functions</h3>

<p class="brush: js notranslate">One reason arrow functions were introduced was to alleviate scope ( <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this</a></code> ) complexities and make executing functions much more intuitive.</p>

<div class="notecard note">
<p class="brush: js notranslate">If <code>this</code> is a mystery, please refer to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">this document</a> for more information on how <code>this</code> works. To summarize, <code>this</code> refers to the instance. Instances are created when the <code>new</code> keyword is invoked. Otherwise, <code>this</code> will default to the window <a href="/en-US/docs/Glossary/Scope">scope</a>.</p>
</div>

<p class="brush: js notranslate"><strong>Traditional functions</strong> default <code>this</code> to the window scope:</p>

<ul>
</ul>

<pre class="brush: js notranslate">window.age = 10; // &lt;-- notice me?
function Person() {
  this.age = 42; // &lt;-- notice me?
  setTimeout(function () { // &lt;-- Traditional function is executing on the window scope
    console.log("this.age", this.age); // yields "10" because the function executes on the window scope
  }, 100);
}

var p = new Person();

</pre>

<p><strong>Arrow functions</strong> do<strong> not </strong>default <code>this</code> to the window <a href="/en-US/docs/Glossary/Scope">scope</a>, rather they execute in the <a href="/en-US/docs/Glossary/Scope">scope</a> they are created:</p>

<pre class="brush: js notranslate">window.age = 10; // &lt;-- notice me?
function Person() {
  this.age = 42; // &lt;-- notice me?
  setTimeout(() =&gt; { // &lt;-- Arrow function executing in the "p" (an instance of Person) scope
    console.log("this.age", this.age); // yields "42" because the function executes on the Person scope
  }, 100);
}

var p = new Person();

</pre>

<p>In our example above, the arrow function does not have its own <code>this</code>. The <code>this</code> value of the enclosing lexical <a href="/en-US/docs/Glossary/Scope">scope</a> is used; arrow functions follow the normal variable lookup rules. So while searching for <code>this</code> which is not present in the current <a href="/en-US/docs/Glossary/Scope">scope</a>, an arrow function ends up finding the <code>this</code> from its enclosing <a href="/en-US/docs/Glossary/Scope">scope</a>.</p>

<p><strong>Relation with strict mode</strong></p>

<p>Given that <code>this</code> comes from the surrounding lexical context, <code><a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a></code> rules with regard to <code>this</code> are ignored.</p>

<pre class="brush: js notranslate">var f = () =&gt; {
    'use strict';
    return this;
};

f() === window; // or the global object</pre>

<p>All other <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a> rules apply normally.</p>

<div class="notecard warning">
<p>NOTE: Please fact-check notes on <a href="/en-US/docs/Web/JavaScript/Reference/Strict_mode">strict mode</a>.</p>
</div>

<h3 id="Arrow_functions_used_as_methods">Arrow functions used as methods</h3>

<p>As stated previously, arrow function expressions are best suited for non-method functions. Let's see what happens when we try to use them as methods:</p>

<pre class="brush: js notranslate">'use strict';

var obj = { // does not create a new scope
  i: 10,
  b: () =&gt; console.log(this.i, this),
  c: function() {
    console.log(this.i, this);
  }
}

obj.b(); // prints undefined, Window {...} (or the global object)
obj.c(); // prints 10, Object {...}</pre>

<p>Arrow functions do not have their own <code>this</code>. Another example involving {{jsxref("Object.defineProperty()")}}:</p>

<pre class="brush: js notranslate">'use strict';

var obj = {
  a: 10
};

Object.defineProperty(obj, 'b', {
  get: () =&gt; {
    console.log(this.a, typeof this.a, this); // undefined 'undefined' Window {...} (or the global object)
    return this.a + 10; // represents global object 'Window', therefore 'this.a' returns 'undefined'
  }
});
</pre>

<h3 id="call_apply_and_bind">call, apply and bind</h3>

<p>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/call">call</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/apply">apply</a></code> and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind"><code>bind</code> </a>methods are <strong>NOT suitable</strong> for Arrow functions -- as they were designed to allow methods to execute within different scopes -- because <strong>Arrow functions establish "this" based on the scope the Arrow function is defined within.</strong></p>

<p>For example <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/call">call</a></code>, <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/apply">apply</a></code> and <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind"><code>bind</code> </a>work as expected with Traditional functions, because we establish the scope for each of the methods:</p>

<pre class="brush: js notranslate">// ----------------------
// Traditional Example
// ----------------------
// A simplistic object with it's very own "this".
var obj = {
    num: 100
}

// Setting "num" on window to show how it is NOT used.
window.num = 2020; // yikes!

// A simple traditional function to operate on "this"
var add = function (a, b, c) {
  return this.num + a + b + c;
}

// call
var result = add.call(obj, 1, 2, 3) // establishing the scope as "obj"
console.log(result) // result 106

// apply
const arr = [1, 2, 3]
var result = add.apply(obj, arr) // establishing the scope as "obj"
console.log(result) // result 106

// bind
var result = add.bind(obj) // establishing the scope as "obj"
console.log(result(1, 2, 3)) // result 106</pre>

<p>With Arrow functions, since our <code>add</code> function is essentially created on the <code>window</code> (global) scope, it will assume <code>this</code> is the window.</p>

<pre class="brush: js notranslate">// ----------------------
// Arrow Example
// ----------------------

// A simplistic object with it's very own "this".
var obj = {
    num: 100
}

// Setting "num" on window to show how it gets picked up.
window.num = 2020; // yikes!

// Arrow Function
var add = (a, b, c) =&gt; this.num + a + b + c;

// call
console.log(add.call(obj, 1, 2, 3)) // result 2026

// apply
const arr = [1, 2, 3]
console.log(add.apply(obj, arr)) // result 2026

// bind
const bound = add.bind(obj)
console.log(bound(1, 2, 3)) // result 2026
</pre>

<p>Perhaps the greatest benefit of using Arrow functions is with DOM-level methods (setTimeout, setInterval, addEventListener) that usually required some kind of closure, call, apply or bind to ensure the function executed in the proper scope.</p>

<p><strong>Traditional Example:</strong></p>

<pre class="brush: js notranslate">var obj = {
    count : 10,
    doSomethingLater : function (){
        setTimeout(function(){ // the function executes on the window scope
            this.count++;
            console.log(this.count);
        }, 300);
    }
}

obj.doSomethingLater(); // console prints "NaN", because the property "count" is not in the window scope.</pre>

<p><strong>Arrow Example:</strong></p>

<pre class="brush: js notranslate">var obj = {
    count : 10,
    doSomethingLater : function(){ // of course, arrow functions are not suited for methods
        setTimeout( () =&gt; { // since the arrow function was created within the "obj", it assumes the object's "this"
            this.count++;
            console.log(this.count);
        }, 300);
    }
}

obj.doSomethingLater();</pre>

<h3 id="No_binding_of_arguments">No binding of <code>arguments</code></h3>

<p>Arrow functions do not have their own <a href="/en-US/docs/Web/JavaScript/Reference/Functions/arguments"><code>arguments</code> object</a>. Thus, in this example, <code>arguments</code> is a reference to the arguments of the enclosing scope:</p>

<pre class="brush: js notranslate">var arguments = [1, 2, 3];
var arr = () =&gt; arguments[0];

arr(); // 1

function foo(n) {
  var f = () =&gt; arguments[0] + n; // foo's implicit arguments binding. arguments[0] is n
  return f();
}

foo(3); // 3 + 3 = 6</pre>

<p>In most cases, using <a href="/en-US/docs/Web/JavaScript/Reference/Functions/rest_parameters">rest parameters</a> is a good alternative to using an <code>arguments</code> object.</p>

<pre class="brush: js notranslate">function foo(n) {
  var f = (...args) =&gt; args[0] + n;
  return f(10);
}

foo(1); // 11</pre>

<h3 id="Use_of_the_new_operator">Use of the <code>new</code> operator</h3>

<p>Arrow functions cannot be used as constructors and will throw an error when used with <code>new</code>.</p>

<pre class="brush: js notranslate">var Foo = () =&gt; {};
var foo = new Foo(); // TypeError: Foo is not a constructor</pre>

<h3 id="Use_of_prototype_property">Use of <code>prototype</code> property</h3>

<p>Arrow functions do not have a <code>prototype</code> property.</p>

<pre class="brush: js notranslate">var Foo = () =&gt; {};
console.log(Foo.prototype); // undefined
</pre>

<h3 id="Use_of_the_yield_keyword">Use of the <code>yield</code> keyword</h3>

<p>The <code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/yield">yield</a></code> keyword may not be used in an arrow function's body (except when permitted within functions further nested within it). As a consequence, arrow functions cannot be used as generators.</p>

<h3 id="Function_body">Function body</h3>

<p>Arrow functions can have either a "concise body" or the usual "block body".</p>

<p>In a concise body, only an expression is specified, which becomes the implicit return value. In a block body, you must use an explicit <code>return</code> statement.</p>

<pre class="brush: js notranslate">var func = x =&gt; x * x;
// concise body syntax, implied "return"

var func = (x, y) =&gt; { return x + y; };
// with block body, explicit "return" needed
</pre>

<h3 id="Returning_object_literals">Returning object literals</h3>

<p>Keep in mind that returning object literals using the concise body syntax <code>params =&gt; {object:literal}</code> will not work as expected.</p>

<pre class="brush: js notranslate">var func = () =&gt; { foo: 1 };
// Calling func() returns undefined!

var func = () =&gt; { foo: function() {} };
// SyntaxError: function statement requires a name</pre>

<p>This is because the code inside braces ({}) is parsed as a sequence of statements (i.e. <code>foo</code> is treated like a label, not a key in an object literal).</p>

<p>You must wrap the object literal in parentheses:</p>

<pre class="brush: js notranslate">var func = () =&gt; ({ foo: 1 });</pre>

<h3 id="Line_breaks">Line breaks</h3>

<p>An arrow function cannot contain a line break between its parameters and its arrow.</p>

<pre class="brush: js notranslate">var func = (a, b, c)
  =&gt; 1;
// SyntaxError: expected expression, got '=&gt;'</pre>

<p>However, this can be amended by putting the line break after the arrow or using parentheses/braces as seen below to ensure that the code stays pretty and fluffy. You can also put line breaks between arguments.</p>

<pre class="brush: js notranslate">var func = (a, b, c) =&gt;
  1;

var func = (a, b, c) =&gt; (
  1
);

var func = (a, b, c) =&gt; {
  return 1
};

var func = (
  a,
  b,
  c
) =&gt; 1;

// no SyntaxError thrown</pre>

<h3 id="Parsing_order">Parsing order</h3>

<p>Although the arrow in an arrow function is not an operator, arrow functions have special parsing rules that interact differently with <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Operator_Precedence">operator precedence</a> compared to regular functions.</p>

<pre class="brush: js notranslate">let callback;

callback = callback || function() {}; // ok

callback = callback || () =&gt; {};
// SyntaxError: invalid arrow-function arguments

callback = callback || (() =&gt; {});    // ok
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_usage">Basic usage</h3>

<pre class="brush: js notranslate">// An empty arrow function returns undefined
let empty = () =&gt; {};

(() =&gt; 'foobar')();
// Returns "foobar"
// (this is an Immediately Invoked Function Expression)

var simple = a =&gt; a &gt; 15 ? 15 : a;
simple(16); // 15
simple(10); // 10

let max = (a, b) =&gt; a &gt; b ? a : b;

// Easy array filtering, mapping, ...

var arr = [5, 6, 13, 0, 1, 18, 23];

var sum = arr.reduce((a, b) =&gt; a + b);
// 66

var even = arr.filter(v =&gt; v % 2 == 0);
// [6, 0, 18]

var double = arr.map(v =&gt; v * 2);
// [10, 12, 26, 0, 2, 36, 46]

// More concise promise chains
promise.then(a =&gt; {
  // ...
}).then(b =&gt; {
  // ...
});

// Parameterless arrow functions that are visually easier to parse
setTimeout( () =&gt; {
  console.log('I happen sooner');
  setTimeout( () =&gt; {
    // deeper code
    console.log('I happen later');
  }, 1);
}, 1);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-arrow-function-definitions', 'Arrow Function Definitions')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.functions.arrow_functions")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://hacks.mozilla.org/2015/06/es6-in-depth-arrow-functions/">"ES6 In Depth: Arrow functions" on hacks.mozilla.org</a></li>
</ul>
